<?php
#########################################################################
# COPYRIGHT NOTICE                                                      #
# Copyright 2008 www.brewsterware.com  All Rights Reserved.             #
#                                                                       #
# If this code works it was written by Joe Brewer, otherwise who knows  #
# who wrote it....                                                      #
#                                                                       #
# Instructions of usage can be found here:                              #
# http://www.brewsterware.com/archives/phpbay-country-detection.html    #
#                                                                       #
# This script may be only used and modified in accordance to the        #
# license agreement attached (eula.txt) except where expressly          #
# noted within commented areas of the code body. This copyright notice  #
# and the comments above and below must remain intact at all times.     #
# By using this code you agree to indemnify Brewsterware, its           #
# corporate agents and affiliates from any liability that might arise   #
# from its use.                                                         #
#                                                                       #
# Selling the code for this program without prior written consent is    #
# expressly forbidden and in violation of Domestic and International    #
# copyright laws.                                                       #
#########################################################################
#                                                                       #
#                                History                                #
#  1.00.00 - Initial version                                            #
#                                                                       #
#########################################################################

class country {

	var $licenseKey = "";
	var $IP = "";
	var $defaultCountry = "US";
	var $ISO = "";
	
	var $ReturnArray = array();

	var $ebayCountries = array(	"US" => array( "siteId" => "0", "language" => "en-US" ),
								"AU" => array( "siteId" => "15", "language" => "en-AU" ),
								"AT" => array( "siteId" => "16", "language" => "de-AT" ),
								"BE" => array( "siteId" => "123", "language" => "nl-BE" ),
								"CA" => array( "siteId" => "2", "language" => "en-CA" ),
								"FR" => array( "siteId" => "71", "language" => "fr-FR" ),
								"DE" => array( "siteId" => "77", "language" => "de-DE" ),
								"HK" => array( "siteId" => "201", "language" => "" ),
								"IN" => array( "siteId" => "203", "language" => "en-IN" ),
								"IE" => array( "siteId" => "205", "language" => "" ),
								"IT" => array( "siteId" => "101", "language" => "it-IT" ),
								"NL" => array( "siteId" => "146", "language" => "nl-NL" ),
								"PL" => array( "siteId" => "212", "language" => "" ),
								"SG" => array( "siteId" => "216", "language" => "" ),
								"ES" => array( "siteId" => "186", "language" => "es-ES" ),
								"CH" => array( "siteId" => "193", "language" => "de-CH" ),
								"GB" => array( "siteId" => "3", "language" => "en-GB" )
								);
	
	
	// Constructor
	function country()
	{
		// Get the IP address
		$this->IP = $this->GetIP();
	}

	
	function setReturnArray()
	{
		if ( is_array( $this->ebayCountries[ $this->ISO ] ) )
		{
			$this->ReturnArray = $this->ebayCountries[ $this->ISO ];
		}
		else
		{
			$this->ReturnArray = $this->ebayCountries[ $this->defaultCountry ];
		}
	}
	
	
	function getCountryFromWeb()
	{
		if ( !$this->licenseKey )
		{
			echo "Please set license key!";
			$this->setReturnArray();
			return;
		}
		
		$query = "http://geoip1.maxmind.com/a?l=" . $this->licenseKey . "&i=" . $this->IP;
		$url = parse_url( $query );
		$host = $url["host"];
		$path = $url["path"] . "?" . $url["query"];
		$timeout = 1;
		
		$fp = fsockopen( $host, 80, $errno, $errstr, $timeout );
		
		if ( $fp )
		{
			fputs( $fp, "GET $path HTTP/1.0\nHost: " . $host . "\n\n" );
			
			while ( !feof($fp) ) $buf .= fgets( $fp, 128 );
			
			$lines = split( "\n", $buf );
			$this->ISO = $lines[ count( $lines ) - 1 ];
			
			fclose( $fp );
		} else
		{
			# use the default country
			$this->ISO = $this->defaultCountry;
		}
		
		$this->setReturnArray();

	}


	function ValidIP( $ip )
	{
		if ( !empty( $ip ) && ip2long( $ip ) != -1 )
		{
			$reserved_ips = array (
				array('0.0.0.0','2.255.255.255'),
				array('10.0.0.0','10.255.255.255'),
				array('127.0.0.0','127.255.255.255'),
				array('169.254.0.0','169.254.255.255'),
				array('172.16.0.0','172.31.255.255'),
				array('192.0.2.0','192.0.2.255'),
				array('192.168.0.0','192.168.255.255'),
				array('255.255.255.0','255.255.255.255')
			);

			foreach ( $reserved_ips as $r )
			{
				$min = ip2long($r[0]);
				$max = ip2long($r[1]);
				if ((ip2long($ip) >= $min) && (ip2long($ip) <= $max)) return false;
			}

			return true;
		} else
		{
			return false;
		}
	}

	function GetIP()
	{
		if ($this->ValidIP($_SERVER["HTTP_CLIENT_IP"]))
		{
			return $_SERVER["HTTP_CLIENT_IP"];
		}

		foreach (explode(",",$_SERVER["HTTP_X_FORWARDED_FOR"]) as $ip)
		{
			if ($this->ValidIP(trim($ip)))
			{
				return $ip;
			}
		}

		if ($this->ValidIP($_SERVER["HTTP_X_FORWARDED"]))
		{
			return $_SERVER["HTTP_X_FORWARDED"];
		} elseif ($this->ValidIP($_SERVER["HTTP_FORWARDED_FOR"]))
		{
			return $_SERVER["HTTP_FORWARDED_FOR"];
		} elseif ($this->ValidIP($_SERVER["HTTP_FORWARDED"]))
		{
			return $_SERVER["HTTP_FORWARDED"];
		} elseif ($this->ValidIP($_SERVER["HTTP_X_FORWARDED"]))
		{
			return $_SERVER["HTTP_X_FORWARDED"];
		} else
		{
			return $_SERVER["REMOTE_ADDR"];
		}
	}

}


?>